<template>
  <div class="user-box">
    <div class="user-box__left">
      <div class="user-box__title">{{ settingTypeTitle }}</div>
      <ObCheckbox
        label="Активно"
        v-model="activeUser"
        class="user-box__active"
        @change="onChangeActive($event)"
      />
      <div
        v-if="isExternalUser"
        class="user-box__more"
        @click="onToggleContact"
      >
        {{ showContactText }}
      </div>
    </div>
    <div class="user-box__center">
      <div class="user-box__list">
        <template v-if="isSystemUser">
          <div class="user-box__row">
            <div class="user-box__col">
              <ObSelect
                label="Получатели уведомлений"
                placeholder="Выберите из списка"
                displayExp="full_name"
                valueExp="uuid"
                v-model="systemUsersValue"
                data-qa="multiselectUsers"
                :items="searchData.length ? searchData : systemUsers"
                :is-multiselect="true"
                :is-dropdown="true"
                :is-tagbox="true"
                @selected="onSelectSystemUsersValue($event)"
                @input="removeUserValue($event)"
            />
            </div>
          </div>
        </template>
        <template v-if="isExternalUser">
          <div class="user-box__row">
            <div class="user-box__col">
              <ObInput
                label="Получатель уведомлений"
                placeholder="Описание получателя"
                v-model="externalTitle"
                data-qa="externalUser"
                @blur="onChangeTextField($event, 'externalRecipientTitle')"/>
            </div>
          </div>
        </template>
        <div class="user-box__row">
          <div class="user-box__toggle">
            <div class="toggle-types">
              <div class="toggle-types__item">
                <ObTooltip
                    :disabled="setting.settingType === 'USER' ? true : !isEmailDisabled"
                    content="Сначала заполните поле контактных данных"
                    position="top-end">
                  <ObCheckbox
                      label="Email"
                      :disabled="setting.settingType === 'USER' ? false : isEmailDisabled"
                      v-model="channelObj.EMAIL"
                      @change="onChangeChannels($event, 'EMAIL')"
                  />
                </ObTooltip>
              </div>
              <div class="toggle-types__item">
                <ObTooltip
                    :disabled="setting.settingType === 'USER' ? true : !isSmsDisabled"
                    content="Сначала заполните поле контактных данных"
                    position="top-end">
                  <ObCheckbox
                      label="SMS"
                      :disabled="true"
                      v-model="channelObj.SMS"
                      @change="onChangeChannels($event, 'SMS')"
                  />
                </ObTooltip>
              </div>
              <div class="toggle-types__item">
                <ObTooltip
                    :disabled="setting.settingType === 'USER' ? true : !isWatsAppDisabled"
                    content="Сначала заполните поле контактных данных"
                    position="top-end">
                  <ObCheckbox
                      label="WhatsApp"
                      disabled
                      v-model="channelObj.WHATSAPP"
                      @change="onChangeChannels($event, 'WHATSAPP')"
                  />
<!--                  :disabled="setting.settingType === 'USER' ? false : isWatsAppDisabled"-->
                </ObTooltip>
              </div>
              <div class="toggle-types__item">
                <ObTooltip
                    :disabled="setting.settingType === 'USER' ? true : !isTelegramDisabled"
                    content="Сначала заполните поле контактных данных"
                    position="top-end">
                  <ObCheckbox
                      label="Telegram"
                      disabled
                      v-model="channelObj.TELEGRAM"
                      @change="onChangeChannels($event, 'TELEGRAM')"
                  />
<!--                  :disabled="setting.settingType === 'USER' ? false : isTelegramDisabled"-->
                </ObTooltip>
              </div>
              <div class="toggle-types__item" v-if="!isExternalUser">
                <ObCheckbox
                    label="ОБОЗ"
                    disabled
                    v-model="channelObj.OBOZ"
                    @change="onChangeChannels($event, 'OBOZ')"
                />
              </div>
            </div>
            <div class="toggle-types _time">
              <div class="toggle-types__item">
                Отправлять:
                <ObInlineSelect
                    :items="frequencySendingValues"
                    v-model="frequencySending"
                    @input="onChangeInlineSelect()"
                />
              </div>
              <template>
                <div class="toggle-types__item" v-if="frequencySending === 'ONLINE'">
                  <TimeList
                    :time="periodFrom"
                    :is-search="true"
                    :is-all-day="true"
                    label="с"
                    @change="onChangeTimeList($event, 'periodFrom')"
                  />
                </div>
                <div class="toggle-types__item" v-if="setting.frequencySending === 'ONLINE'">
                  <TimeList
                    :time="periodTo"
                    :is-search="true"
                    :is-all-day="true"
                    label="по"
                    @change="onChangeTimeList($event, 'periodTo')"
                  />
                </div>
                <div class="toggle-types__item" v-if="setting.frequencySending !== 'ONLINE'">
                  <TimeList
                      :time="timeAt"
                      :is-search="true"
                      :is-all-day="true"
                      label="в"
                      @change="onChangeTimeList($event, 'timeAt')"
                  />
                </div>
                <span class="utc"> (UTC+3)</span>
              </template>
            </div>
          </div>
        </div>
        <template v-if="isToggleContact">
            <div class="user-box__row">
              <div class="user-box__col">
                <ObInput
                    label="Email"
                    :is-valid="isEmailValid"
                    validation-message="Некорректный Email"
                    placeholder="Укажите контактные данные"
                    v-model="externalEmail"
                    data-qa="externalEmailUser"
                    @blur="onChangeTextField($event, 'externalRecipientEmail')"
                />
              </div>
              <div class="user-box__col">
                <ObInput
                    label="SMS"
                    mask="+7 (999) 999-9999"
                    :is-valid="isSmsValid"
                    validation-message="Некорректный телефон"
                    placeholder="+7 (123) 443-45-45"
                    v-model="externalSMS"
                    data-qa="externalSmsUser"
                    @blur="onChangeTextField($event, 'externalRecipientSms')"
                />
              </div>
            </div>
            <div class="user-box__row">
              <div class="user-box__col">
                <ObInput
                    label="WhatsApp"
                    placeholder="+7 (123) 443-45-54"
                    disabled
                    v-model="externalWhatsApp"
                    data-qa="externalWhatsAppUser"
                    @blur="onChangeTextField($event, 'externalRecipientWhatsapp')"
                />
              </div>
              <div class="user-box__col">
                <ObInput
                    label="Telegram"
                    disabled
                    placeholder="Укажите контактные данные"
                    v-model="externalTelegram"
                    data-qa="externalTelegramUser"
                    @blur="onChangeTextField($event, 'externalRecipientTelegram')"
                />
              </div>
            </div>
          </template>
      </div>
    </div>
    <div class="user-box__right">
      <i class="icon close-sm" @click="openModal()" />
    </div>
    <ObModal
        ref="remove-setting"
        title="Удаление получателей уведомлений"
        size="medium"
    >
      <template>
        <div v-if="isSystemUser">
          <div class="modal-text">Получателей уведомлений: {{setting.recipientInfo.length}}</div>
          <div class="modal-text">
            Все настройки уведомлений для этой группы получателей будут удалены, а рассылка будет отменена.
          </div>
        </div>
        <div v-else>
          <div class="modal-text">Получатель: {{externalTitle}}</div>
          <div class="modal-text">
            Все настройки уведомлений и контакты для этого получателя будут удалены, а рассылка будет отменена.
          </div>
        </div>
        <div class="modal-buttons">
          <ObButton
              label="Да, удалить"
              @click="onRemoveSetting()"
              data-qa="removeBtn"
          />
          <ObButton
              class="close-button"
              type="flat"
              label="Не удалять"
              @click="closeModal()"
              data-qa="closeBtn"
          />
        </div>
      </template>
    </ObModal>
  </div>
</template>

<script>
import api from '@/api';
import { uuid } from 'vue-uuid';
import TimeList from './timeList';
import ObInput from 'common-components/src/obComponents/obInput';
import ObSelect from 'common-components/src/obComponents/obSelect';
import ObCheckbox from 'common-components/src/obComponents/obCheckbox';
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect';
import ObModal from 'common-components/src/obComponents/obModal';
import ObButton from 'common-components/src/obComponents/obButton';
import ObTooltip from 'common-components/src/obComponents/obTooltip';

export default {
  name: 'UserForm',
  components: {
    TimeList,
    ObInput,
    ObSelect,
    ObTooltip,
    ObModal,
    ObButton,
    ObCheckbox,
    ObInlineSelect
  },
  props: {
    settingType: {
      type: String,
      default: 'SYSTEM'
    },
    systemUsers: {
      type: Array,
      default: () => []
    },
    setting: {
      type: Object,
      default: () => {}
    },
    keyWord: {
      type: String,
      default: ''
    }
  },
  watch: {
    keyWord (word) {
      if (word.length) {
        this.searchData = this.systemUsers.filter((k) => k.full_name.toLowerCase().includes(word.toLowerCase()));
      } else {
        this.searchData = [];
      }
    }
  },
  data () {
    return {
      // eslint-disable-next-line no-useless-escape
      reg: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/,
      regPhone: /^[0-9]{10}$/,
      userUuid: '',
      frequencySendingValues: [
        {
          uuid: 'ONLINE',
          title: 'Онлайн'
        },
        {
          uuid: 'ONCE_A_DAY',
          title: 'Раз в день'
        },
        {
          uuid: 'ON_MONDAY',
          title: 'Понедельник'
        },
        {
          uuid: 'ON_TUESDAY',
          title: 'Вторник'
        },
        {
          uuid: 'ON_WEDNESDAY',
          title: 'Среда'
        },
        {
          uuid: 'ON_THURSDAY',
          title: 'Четверг'
        },
        {
          uuid: 'ON_FRIDAY',
          title: 'Пятница'
        },
        {
          uuid: 'ON_SATURDAY',
          title: 'Суббота'
        },
        {
          uuid: 'ON_SUNDAY',
          title: 'Воскресенье'
        }],
      frequencySending: this.setting.frequencySending || 'ONLINE',
      isToggleContact: this.settingType === 'EXTERNAL_RECIPIENT',
      activeUser: this.setting.isActive,
      externalTitle: null,
      externalEmail: null,
      externalSMS: null,
      externalWhatsApp: null,
      externalTelegram: null,
      channelObj: {
        EMAIL: false,
        SMS: false,
        WHATSAPP: false,
        TELEGRAM: false,
        OBOZ: false
      },
      channels: [],
      searchData: [],
      systemUsersValue: [],
      timeAt: this.setting.timeAt || null,
      periodTo: this.setting.periodTo || null,
      periodFrom: this.setting.periodFrom || null
    }
  },
  mounted () {
    this.userUuid = uuid.v4();
    if(this.setting.recipientInfo.length !== 0){
      this.externalTitle = this.setting.recipientInfo[0].externalRecipientTitle;
      this.externalEmail = this.setting.recipientInfo[0].externalRecipientEmail;
      this.externalSMS = this.setting.recipientInfo[0].externalRecipientSms;
      this.externalWhatsApp  = this.setting.recipientInfo[0].externalRecipientWhatsapp;
      this.externalTelegram  = this.setting.recipientInfo[0].externalRecipientTelegram;
    }
    this.periodFrom = this.setting.periodFrom
    if (this.setting.recipientInfo.length) {
      this.setting.recipientInfo.forEach(value => {
        this.systemUsersValue.push(value.userUuid);
      })
    }
    this.setting.channels?.forEach(item => {
      this.channelObj[item] = true;
    });
  },
  computed: {
    isEmailDisabled(){
      return this.externalEmail === null;
    },
    isSmsDisabled(){
      return this.externalSMS === null;
    },
    isWatsAppDisabled(){
      return this.externalWhatsApp === null;
    },
    isTelegramDisabled(){
      return this.externalTelegram === null;
    },
    isEmailValid () {
      if (this.externalEmail === null) return

      return this.reg.test(this.externalEmail);
    },
    isSmsValid () {
      if (this.externalSMS === null) return

      return this.regPhone.test(this.externalSMS);
    },
    isSystemUser () {
      return this.settingType === 'USER';
    },
    isExternalUser () {
      return this.settingType === 'EXTERNAL_RECIPIENT';
    },
    settingTypeTitle () {
      return this.isSystemUser ? 'Пользователи системы' : 'Внешний получатель';
    },
    showContactText () {
      return this.isToggleContact ? 'Скрыть контакты' : 'Показать контакты';
    }
  },
  methods: {
    removeUserValue (listUuid) {
      let user = this.setting.recipientInfo.filter(key => listUuid.indexOf(key.userUuid) === -1);
      if (user.length) {
        this.onSelectSystemUsersValue({ uuid: user[0].userUuid })
      }
    },
    checkBoxDisabled(type){
      this.telegramDisabled = type;
      this.emailDisabled = type;
      this.whatsAppDisabled = type;
      this.smsDisabled = type;
      this.obozDisabled = type;
    },
    async onSelectSystemUsersValue (user) {
      let _user = {
        settingUuid: uuid.v4(),
        userUuid: user.uuid,
        externalRecipientEmail: null,
        externalRecipientSms: null,
        externalRecipientTelegram: null,
        externalRecipientTitle: null,
        externalRecipientWhatsapp: null,
      };

      const el = this.setting.recipientInfo.find(item => item.userUuid === user.uuid);

      if (el) {
        await api.notice.removeSetting(el.settingUuid)
          .then(() => {
            const data = this.setting.recipientInfo.filter(key => key.settingUuid !== el.settingUuid);
            this.setting.recipientInfo = data;
          })
          .catch((error) => {
            console.error('error', error);
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка при удаление данных'
            });
          });
      } else {
        this.setting.recipientInfo.push(_user);
      }
      this.onUpdateSetting();
    },
    onChangeActive(event){
      this.setting.isActive = event;
      this.onUpdateSetting()
    },
    onChangeChannels(isChecked, name) {
      if(isChecked){
        this.setting.channels.push(name)
      } else {
        this.setting.channels.splice(this.setting.channels.indexOf(name),1)
      }
      this.onUpdateSetting()
    },
    onToggleContact() {
      this.isToggleContact = !this.isToggleContact;
    },
    onChangeTimeList(item, type) {
      this.setting[type] = item.title+'+03:00';
      this.periodTo = this.setting.periodTo
      this.periodFrom = this.setting.periodFrom
      this.timeAt = this.setting.timeAt
      this.onUpdateSetting()
    },
    onChangeTextField() {
      if (!this.isEmailValid || !this.isSmsValid) return;

      if (this.setting.recipientInfo.some(item => item.settingUuid)) {
        this.setting.recipientInfo[0].externalRecipientEmail = this.externalEmail || null;
        this.setting.recipientInfo[0].externalRecipientSms = this.externalSMS || null;
        this.setting.recipientInfo[0].externalRecipientTelegram = this.externalTelegram || null;
        this.setting.recipientInfo[0].externalRecipientTitle = this.externalTitle || null;
        this.setting.recipientInfo[0].externalRecipientWhatsapp = this.externalWhatsApp || null;
      }
      else {
        let _user = {
          settingUuid: uuid.v4(),
          userUuid: null,
          externalRecipientEmail: this.externalEmail || null,
          externalRecipientSms: this.externalSMS,
          externalRecipientTelegram: this.externalTelegram,
          externalRecipientTitle: this.externalTitle,
          externalRecipientWhatsapp: this.externalWhatsApp,
        };
        this.setting.recipientInfo.push(_user)
      }
      this.onUpdateSetting();
    },
    onUpdateSetting () {
      this.$emit('update', this.setting);
    },
    openModal(){
      this.$refs['remove-setting'].open();
    },
    closeModal(){
      this.$refs['remove-setting'].close();
    },
    onRemoveSetting () {
      if(this.settingType === 'EXTERNAL_RECIPIENT'){
         api.notice.removeSetting(this.setting.recipientInfo[0].settingUuid)
      }
      else {
        this.setting.recipientInfo.forEach(value=>{
          api.notice.removeSetting(value.settingUuid)
        })
      }
      this.$emit('remove', this.setting.notificationTypeUuid);
      this.closeModal()
    },
    onChangeInlineSelect() {
    if( this.frequencySending === 'ONLINE' ){
      this.timeAt = null
      this.periodTo = '00:00+03:00'
      this.periodFrom = '00:00+03:00'
    }
    else{
      if(this.timeAt === null){
        this.timeAt = '00:00+03:00'
      }
      this.periodTo = null
      this.periodFrom = null
    }
    this.setting.timeAt = this.timeAt;
    this.setting.periodTo = this.periodTo;
    this.setting.periodFrom = this.periodFrom;
    this.setting.frequencySending = this.frequencySending;
    this.onUpdateSetting()
    }
  }
}
</script>

<style lang="scss" scoped>
.modal-text{
  color: $topMenuTextHover;
  margin-top: 10px;
}
.modal-buttons{
  margin-top: 40px;
  display: flex;
  .close-button{
    margin-left: 10px;
  }
}
.user-box {
  display: flex;
  justify-content: space-between;
  padding-left: 30px;
  overflow: hidden;
  border-bottom: 1px solid $light-lavender;
  margin-bottom: 20px;

  &__left {
    flex: 0 1 240px;
  }

  &__center {
    flex: 1 1 auto;
    padding: 0 0 23px 0;
  }

  &__right {
    flex: 0 1 auto;

    .icon.close-sm {
      font-size: 16px;
      width: 16px;
      margin-left: 20px;
      color: $color-grey-span;

      &:hover {
        cursor: pointer;
      }
    }
  }

  &__row {
    display: flex;
    justify-content: space-between;
    margin-bottom: 10px;
  }

  &__col {
    margin-right: 10px;
    flex: 1 1 auto;

    &:last-child {
      margin-right: 0;
    }
  }

  &__more {
    display: inline-block;
    color: $color-blue-navy-blue;
    border-bottom: 1px dashed $color-blue-navy-blue;

    &:hover {
      cursor: pointer;
    }
  }

  &__active {
    margin-bottom: 15px;
  }

  &__title {
    margin-bottom: 10px;
  }

  &__list {
    margin-bottom: 15px;
  }

  &__toggle {
    display: flex;
  }

  .toggle-types {
    margin-right: 34px;
    display: flex;
    align-items: center;
    flex-wrap: wrap;

    &__item {
      display: inline-block;
      margin-right: 15px;
    }

    &._time {
      .toggle-types__item {
        vertical-align: -4px;
      }
    }
  }
  .utc{
    color: $color-grey-span;
  }

}
</style>
